var hostName = "com.andapt.amplink"
var nativePort = null
var webPort = null
var lastMessage = null

function sendResponse(response) {
	if (webPort) {
    webPort.postMessage(response)
  } else {
    console.log('port to content script is not found.')
  }
}

function onNativeMessage(message) {
	console.log("got message from native: " + JSON.stringify(message))
	sendResponse(message)
}

chrome.runtime.onConnect.addListener(function(port) {
	webPort = port
	port.onMessage.addListener(function(msg) {
		lastMessage = msg
		switch (msg.action) {
			case 'check':
				chrome.runtime.sendNativeMessage(hostName, msg, function(response) {
					if (chrome.runtime.lastError) {
						sendResponse({status: chrome.runtime.lastError.message, nativeInstalled: false, id: msg.id})
					} else {
						response.nativeInstalled = true
						sendResponse(response)
					}
				})
				break
			default:
				if (nativePort == null) {
					nativePort = chrome.runtime.connectNative(hostName)
					nativePort.onMessage.addListener(onNativeMessage)
					nativePort.onDisconnect.addListener(function() {
						if (lastMessage) {
							if (chrome.runtime.lastError) {
								var error = chrome.runtime.lastError.message
								console.log(error)
								if (error != "Native host has exited.") {
                  sendResponse({status: chrome.runtime.lastError.message, id: lastMessage.id})
                }
							} else {
                sendResponse({status: null, id: lastMessage.id})
              }
						}
						nativePort = null
					})
				}
				nativePort.postMessage(msg)
		}
	})
})
